#!/bin/sh

##############################################################
# bwlog (rewritten) - Version 1.0                            #
# changed by littlewhoo                                      #
# by xadas - produces daily bandwidth logs                   #
# based on a script by littlewhoo                            #
##############################################################

#####check for running instance#####
if [ -f "./data/bwlog.pid" ]; then
  pid=$(cat ./data/bwlog.pid)
  rm ./data/bwlog.pid
fi
if [ "$pid" = "" ]; then
  pid="wrtbwlog_nopid"
fi
echo $$ > ./data/bwlog.pid

if [ "$(ps|grep $pid|grep bwlog.sh)" != "" ]; then
  kill $pid
fi

if [ "1" = "1" ]; then
  ######interface to listen on#####
  if [ -f ./data/config ]; then
    INTERF=$(cat "./data/config"|grep "wrt_tinter"|cut -d '=' -f2)
  fi

  if [ "$INTERF" = "" ]; then
    INTERF="vlan1"
  fi
  
  #####get current rx and tx byte count#####
  brx=$(grep $INTERF: /proc/net/dev|cut -d : -f2|sed -e 's/^ *//'|sed -e 's/[^0-9] */ /g'|cut -d ' ' -f1)
  btx=$(grep $INTERF: /proc/net/dev|cut -d : -f2|sed -e 's/^ *//'|sed -e 's/[^0-9] */ /g'|cut -d ' ' -f9)

  #####get last rx byte count#####
  if [ -f "./data/${INTERF}rx" ] && [ "$(find ./data/ -name "${INTERF}rx" -mtime -1)" != "" ]; then
    lbrx=$(cat "./data/${INTERF}rx")
    rm "./data/${INTERF}rx"
  fi
  if [ "$lbrx" = "" ]; then
    lbrx="$brx"
  fi
  echo $brx > "./data/${INTERF}rx"

  #####get last tx byte count#####
  if [ -f "./data/${INTERF}tx" ] && [ "$(find ./data/ -name "${INTERF}tx" -mtime -1)" != "" ]; then
    lbtx=$(cat "./data/${INTERF}tx")
    rm "./data/${INTERF}tx"
  fi
  if [ "$lbtx" = "" ]; then
    lbtx="$btx"
  fi
  echo $btx > "./data/${INTERF}tx"

  #####bytes received since last run#####
  drx=$(echo $brx $lbrx | awk '{print $1 - $2}')
  if [ $(expr substr $drx 1 1) = "-" ]; then
    drx=$brx
  fi

  #####bytes sent since last run#####
  dtx=$(echo $btx $lbtx | awk '{print $1 - $2}')
  if [ $(expr substr $dtx 1 1) = "-" ]; then
    dtx=$btx
  fi

  #####bytes sent/received per minute#####
  if [ -f ./data/speed ]; then
    rm ./data/speed
  fi
  echo "$drx" > "./data/speed"
  echo "$dtx" >> "./data/speed"
  
  #####initialize logfiles##### 
  curdate=$(date +"%y%m%d")
  if [ ! -f ./data/$curdate ]; then
    echo "0" > ./data/$curdate
    echo "0" >> ./data/$curdate
  fi
    
  #####get current log contents#####
  trx=$(sed -n '1,1p' ./data/$curdate)
  ttx=$(sed -n '2,2p' ./data/$curdate)
    
  #####add new traffic#####
  trx=$(echo $trx $drx | awk '{print $1 + $2}')
  ttx=$(echo $ttx $dtx | awk '{print $1 + $2}')
    
  #####remove old log#####
  rm ./data/$curdate
    
  #####save new log contents#####
  echo "$trx" > ./data/$curdate
  echo "$ttx" >> ./data/$curdate
fi
