#!./haserl
Content-Type: text/html

<?
./header.sh

#####execute commands#####
if [ "$FORM_command" != "" ]; then
  echo "<h3>Please wait, executing commands '$FORM_command'...</h3>"
  echo "<h3>This can take up to a few minutes!</h3>"
  $FORM_command
fi

echo "<h3>Please wait, reading/writing configuration file...</h3>"

echo "<p>For a detailed description of all these configuration options please see the"
echo "<a href=\"http://www.hetos.de/bwlog.html#config\">documentation</a> at the WRTbwlog homepage.</p>"

#####read configuration file#####
if [ -f "./data/config" ]; then
  trafac=$(cat "./data/config"|grep "wrt_trafac"|cut -d '=' -f2)
  stbill=$(cat "./data/config"|grep "wrt_stbill"|cut -d '=' -f2)
  spdadj=$(cat "./data/config"|grep "wrt_spdadj"|cut -d '=' -f2)
  spdupd=$(cat "./data/config"|grep "wrt_spdupd"|cut -d '=' -f2)
  limiac=$(cat "./data/config"|grep "wrt_limiac"|cut -d '=' -f2)
  limit1=$(cat "./data/config"|grep "wrt_limit1"|cut -d '=' -f2)
  limit2=$(cat "./data/config"|grep "wrt_limit2"|cut -d '=' -f2)
  aclim1=$(cat "./data/config"|grep "wrt_aclim1"|cut -d '=' -f2)
  aclim2=$(cat "./data/config"|grep "wrt_aclim2"|cut -d '=' -f2)
  backac=$(cat "./data/config"|grep "wrt_backac"|cut -d '=' -f2)
  destbc=$(cat "./data/config"|grep "wrt_destbc"|cut -d '=' -f2)
  pathbc=$(cat "./data/config"|grep "wrt_pathbc"|cut -d '=' -f2)
  intbac=$(cat "./data/config"|grep "wrt_intbac"|cut -d '=' -f2)
  ftpbac=$(cat "./data/config"|grep "wrt_ftpbac"|cut -d '=' -f2)
  usrbac=$(cat "./data/config"|grep "wrt_usrbac"|cut -d '=' -f2)
  pasbac=$(cat "./data/config"|grep "wrt_pasbac"|cut -d '=' -f2)
  rotbac=$(cat "./data/config"|grep "wrt_rotbac"|cut -d '=' -f2)
  acceac=$(cat "./data/config"|grep "wrt_acceac"|cut -d '=' -f2)
  dwnloc=$(cat "./data/config"|grep "wrt_dwnloc"|cut -d '=' -f2)
  mhport=$(cat "./data/config"|grep "wrt_mhport"|cut -d '=' -f2)
  tinter=$(cat "./data/config"|grep "wrt_tinter"|cut -d '=' -f2)
  debugm=$(cat "./data/config"|grep "wrt_debugm"|cut -d '=' -f2)
  styles=$(cat "./data/config"|grep "wrt_styles"|cut -d '=' -f2)
  unitdv=$(cat "./data/config"|grep "wrt_unitdv"|cut -d '=' -f2)
  wlnhst=$(cat "./data/config"|grep "wrt_wlnhst"|cut -d '=' -f2)
  wlnmac=$(cat "./data/config"|grep "wrt_wlnmac"|cut -d '=' -f2)
  wlncmd=$(cat "./data/config"|grep "wrt_wlncmd"|cut -d '=' -f2)
fi
if [ -f "./.htpasswd" ]; then
  htuser=$(sed -n '1,1p' ./.htpasswd|cut -d ':' -f1)
  htpass=$(sed -n '1,1p' ./.htpasswd|cut -d ':' -f2)
fi

#####update config#####
restart=""

if [ "$FORM_trafac" != "" ]; then
  trafac="$FORM_trafac"
fi

if [ "$FORM_stbill" != "" ]; then
  stbill="$FORM_stbill"
fi

if [ "$FORM_spdadj" != "" ]; then
  spdadj="$FORM_spdadj"
fi

if [ "$FORM_spdupd" != "" ]; then
  spdupd="$FORM_spdupd"
fi

if [ "$FORM_limiac" != "" ]; then
  limiac="$FORM_limiac"
fi

if [ "$FORM_limit1" != "" ]; then
  limit1="$FORM_limit1"
fi

if [ "$FORM_limit2" != "" ]; then
  if [ "$FORM_limit2" -lt "$limit1" ]; then
    limit2="$limit1"
  else
    limit2="$FORM_limit2"
  fi
fi

if [ "$FORM_cnfupd3"  = "1" ];then
  aclim1="$FORM_aclim1"
  aclim2="$FORM_aclim2"
fi

if [ "$FORM_backac" != "" ]; then
  backac="$FORM_backac"
fi
  
if [ "$FORM_destbc" != "" ]; then
  destbc="$FORM_destbc"
fi
      
if [ "$FORM_pathbc" != "" ]; then
  pathbc="$FORM_pathbc"
fi
          
if [ "$FORM_intbac" != "" ]; then
  intbac="$FORM_intbac"
fi
      
if [ "$FORM_ftpbac" != "" ]; then
  ftpbac="$FORM_ftpbac"
fi
          
if [ "$FORM_usrbac" != "" ]; then
  usrbac="$FORM_usrbac"
fi
              
if [ "$FORM_pasbac" != "" ]; then
  pasbac="$FORM_pasbac"
fi
                
if [ "$FORM_rotbac" != "" ]; then
  rotbac="$FORM_rotbac"
fi

if [ "$FORM_acceac" != "" ]; then
  acceac="$FORM_acceac"
fi
                  
if [ "$FORM_dwnloc" != "" ]; then
  dwnloc="$FORM_dwnloc"
fi

if [ "$FORM_mhport" != "" ]; then
  mhport="$FORM_mhport"
  restart="${restart}h"
fi
  
if [ "$FORM_tinter" != "" ]; then
  tinter="$FORM_tinter"
fi

if [ "$FORM_debugm" != "" ]; then
  debugm="$FORM_debugm"
fi

if [ "$FORM_cnfupd1"  = "1" ];then
  htuser="$FORM_htuser"
  htpass="$FORM_htpass"
fi

if [ "$FORM_styles" != "" ]; then
  styles="$FORM_styles"
fi

if [ "$FORM_unitdv" != "" ]; then
  unitdv="$FORM_unitdv"
fi

if [ "$FORM_cnfupd4"  = "1" ];then
  wlnhst="$FORM_wlnhst"
  wlnmac="$FORM_wlnmac"
  wlncmd="$FORM_wlncmd"
fi

#####if no data in config file, use default values#####
if [ "$trafac" = "" ]; then
  trafac="1"
fi

if [ "$stbill" = "" ]; then
  stbill="01"
fi

if [ "$spdadj" = "" ]; then
  spdadj="1100"
fi

if [ "$spdupd" = "" ]; then
  spdupd="5"
fi

if [ "$limiac" = "" ]; then
  limiac="0"
fi

if [ "$limit1" = "" ]; then
  limit1="0"
fi

if [ "$limit2" = "" ]; then
  limit2="0"
fi

if [ "$backac" = "" ]; then
  backac="1"
fi

if [ "$destbc" = "" ]; then
  destbc="FTP"
fi
  
if [ "$pathbc" = "" ]; then
  pathbc="/tmp/"
fi

if [ "$intbac" = "" ]; then
  intbac="300"
fi
  
if [ "$ftpbac" = "" ]; then
  ftpbac="192.168.1.100"
fi

if [ "$usrbac" = "" ]; then
  usrbac="wrt54g"
fi
  
if [ "$pasbac" = "" ]; then
  pasbac="wrt54g"
fi

if [ "$rotbac" = "" ]; then
  rotbac="/"
fi

if [ "$acceac" = "" ]; then
  acceac="0"
fi

if [ "$dwnloc" = "" ]; then
  dwnloc="http://wrt54g.hetos.de/"
fi

if [ "$mhport" = "" ]; then
  mhport="8000"
fi
  
if [ "$tinter" = "" ]; then
  tinter="vlan1"
fi
  
if [ "$debugm" = "" ]; then
  debugm="0"
fi

if [ "$styles" = "" ]; then
  styles="black_on_grey.css"
fi

if [ "$unitdv" = "" ]; then
  unitdv="1048576"
fi

#####save config#####

if [ "1" ]; then
  if [ -f ./data/config ]; then
    rm ./data/config
  fi
  
  echo "wrt_trafac=${trafac}" > ./data/config
  echo "wrt_stbill=${stbill}" >> ./data/config
  echo "wrt_spdadj=${spdadj}" >> ./data/config
  echo "wrt_spdupd=${spdupd}" >> ./data/config
  echo "wrt_limiac=${limiac}" >> ./data/config
  echo "wrt_limit1=${limit1}" >> ./data/config
  echo "wrt_limit2=${limit2}" >> ./data/config
  echo "wrt_aclim1=${aclim1}" >> ./data/config
  echo "wrt_aclim2=${aclim2}" >> ./data/config
  echo "wrt_backac=${backac}" >> ./data/config
  echo "wrt_destbc=${destbc}" >> ./data/config
  echo "wrt_pathbc=${pathbc}" >> ./data/config
  echo "wrt_intbac=${intbac}" >> ./data/config
  echo "wrt_ftpbac=${ftpbac}" >> ./data/config
  echo "wrt_usrbac=${usrbac}" >> ./data/config
  echo "wrt_pasbac=${pasbac}" >> ./data/config
  echo "wrt_rotbac=${rotbac}" >> ./data/config
  echo "wrt_acceac=${acceac}" >> ./data/config
  echo "wrt_dwnloc=${dwnloc}" >> ./data/config
  echo "wrt_mhport=${mhport}" >> ./data/config
  echo "wrt_tinter=${tinter}" >> ./data/config
  echo "wrt_debugm=${debugm}" >> ./data/config
  echo "wrt_styles=${styles}" >> ./data/config
  echo "wrt_unitdv=${unitdv}" >> ./data/config
  echo "wrt_wlnhst=${wlnhst}" >> ./data/config
  echo "wrt_wlnmac=${wlnmac}" >> ./data/config
  echo "wrt_wlncmd=${wlncmd}" >> ./data/config
fi

if [ "$FORM_cnfupd1"  = "1" ];then
  if [ -f ./.htpasswd ]; then
    rm ./.htpasswd
  fi
  if [ "$htuser" != "" ] && [ "$htpass" != "" ]; then
    echo "${htuser}:${htpass}" > ./.htpasswd
  fi
fi

#####webinterface#####    
echo "<table id=\"tabconf\">"

#####Genreal configuration#####
  
echo "<tr><td></td><td><h3>General (<a href="http://www.hetos.de/bwlog.html#config_general">?</a>)</h3></td></tr>"

echo "<form action=\"http://$HTTP_HOST$SCRIPT_NAME\" method=\"POST\" >"
echo "<input type=\"hidden\" name=\"command\" value=\"/sbin/reboot\">"
echo "<tr><td></td><td><input type=\"submit\" class=\"ButtonWarn\" style=\"width: 100%;\" value=\"Reboot\" ></td></tr>"
echo "</form>"

echo "<form action=\"http://$HTTP_HOST$SCRIPT_NAME\" method=\"POST\" >"

echo "<tr><td>Update server:</td>"
echo "<td><input type=\"text\" class=\"TextBox\" style=\"width: 100%;\" name=\"dwnloc\" value=\"$dwnloc\" ></td></tr>"

echo "<tr><td>Mini_httpd port:</td>"
echo "<td><input type=\"text\" class=\"TextBox\" style=\"width: 100%;\" name=\"mhport\" value=\"$mhport\" ></td></tr>"

echo "<tr><td>Username:</td>"
echo "<td><input type=\"text\" class=\"TextBox\" style=\"width: 100%;\" name=\"htuser\" value=\"$htuser\" ></td></tr>"

echo "<tr><td class=\"mark\">Password DES hash (not cleartext!):</td>"
echo "<td><input type=\"text\" class=\"TextBox\" style=\"width: 100%;\" name=\"htpass\" value=\"$htpass\" ></td></tr>"

echo "<tr><td>Debug mode:</td>"
echo "<td><input type=\"text\" class=\"TextBox\" name=\"debugm\" value=\"$debugm\" ></td></tr>"

echo "<tr><td>Layout:</td>"
echo "<td><select name=\"styles\" class=\"TextBox\">"
for style in $(ls *.css)
do
echo "<option"

if [ "$style" = "$styles" ]; then
  echo " selected "
fi

echo "value=\"$style\">$(echo "$style"|cut -d '.' -f1)</option>"
done
echo "</select></td></tr>"

echo "<input type=\"hidden\" name=\"cnfupd1\" value=\"1\" >"
echo "<tr><td></td><td><input type=\"submit\" class=\"Button\" style=\"width: 100%;\" value=\"Save\" ></td></tr>"
echo "</form>"
echo "<tr><td id=\"ruler\"/><td id=\"ruler\"/></tr>"

#####Traffic configuration#####

echo "<tr><td></td><td><h3>Traffic Statistics(<a href="http://www.hetos.de/bwlog.html#config_trafstat">?</a>)</h3></td></tr>"

echo "<form action=\"http://$HTTP_HOST$SCRIPT_NAME\" method=\"POST\" >"
echo "<input type=\"hidden\" name=\"command\" value=\"rm ./data/[0-9]* ./data/tot* ./data/speed ./data/traffic.slk\" >"
echo "<tr><td></td><td><input type=\"submit\" class=\"ButtonWarn\" style=\"width: 100%;\" value=\"Clear Traffic Statistics\" ></td></tr>"
echo "</form>"

echo "<form action=\"http://$HTTP_HOST$SCRIPT_NAME\" method=\"POST\" >"

echo "<tr><td>Traffic logging active:</td>"
echo "<td><input type=\"text\" class=\"TextBox\" style=\"width: 100%;\" name=\"trafac\" value=\"$trafac\" ></td></tr>"

echo "<tr><td>First day of billing period:</td>"
echo "<td><input type=\"text\" class=\"TextBox\" style=\"width: 100%;\" name=\"stbill\" value=\"$stbill\" ></td></tr>"

echo "<tr><td>1 MB = ? Byte:</td>"
echo "<td><input type=\"text\" class=\"TextBox\" style=\"width: 100%;\" name=\"unitdv\" value=\"$unitdv\" ></td></tr>"

echo "<tr><td>D/U Speed adjustment factor:</td>"
echo "<td><input type=\"text\" class=\"TextBox\" style=\"width: 100%;\" name=\"spdadj\" value=\"$spdadj\" ></td></tr>"

echo "<tr><td>D/U Speed update interval:</td>"
echo "<td><input type=\"text\" class=\"TextBox\" style=\"width: 100%;\" name=\"spdupd\" value=\"$spdupd\" ></td></tr>"

echo "<tr><td>Interface to log:</td>"
echo "<td><input type=\"text\" class=\"TextBox\" style=\"width: 100%;\" name=\"tinter\" value=\"$tinter\" ></td></tr>"

echo "<input type=\"hidden\" name=\"cnfupd2\" value=\"1\" >"
echo "<tr><td></td><td><input type=\"submit\" class=\"Button\" style=\"width: 100%;\" value=\"Save\" ></td></tr>"
echo "</form>"
echo "<tr><td id=\"ruler\"/><td id=\"ruler\"/></tr>"

#####Traffic sentry#####

echo "<tr><td></td><td><h3>Traffic Sentry(<a href="http://www.hetos.de/bwlog.html#config_trafsentry">?</a>)</h3></td></tr>"

echo "<form action=\"http://$HTTP_HOST$SCRIPT_NAME\" method=\"POST\" >"
echo "<input type=\"hidden\" name=\"command\" value=\"rm ./data/lastac\" >"
echo "<tr><td></td><td><input type=\"submit\" class=\"Button\" style=\"width: 100%;\" value=\"Reset Trigger\" ></td></tr>"
echo "</form>"

echo "<form action=\"http://$HTTP_HOST$SCRIPT_NAME\" method=\"POST\" >"

echo "<tr><td>Traffic Sentry active:</td>"
echo "<td><input type=\"text\" class=\"TextBox\" style=\"width: 100%;\" name=\"limiac\" value=\"$limiac\" ></td></tr>"

echo "<tr><td>First Traffic limit (MB):</td>"
echo "<td><input type=\"text\" class=\"TextBox\" style=\"width: 100%;\" name=\"limit1\" value=\"$limit1\" ></td></tr>"

echo "<tr><td>Custom script on limit 1:</td>"
echo "<td><input type=\"text\" class=\"TextBox\" style=\"width: 100%;\" name=\"aclim1\" value=\"$aclim1\" ></td></tr>"

echo "<tr><td>Second Traffic limit (MB):</td>"
echo "<td><input type=\"text\" class=\"TextBox\" style=\"width: 100%;\" name=\"limit2\" value=\"$limit2\" ></td></tr>"

echo "<tr><td>Custom script on limit 2:</td>"
echo "<td><input type=\"text\" class=\"TextBox\" style=\"width: 100%;\" name=\"aclim2\" value=\"$aclim2\" ></td></tr>"

echo "<input type=\"hidden\" name=\"cnfupd3\" value=\"1\" >"
echo "<tr><td></td><td><input type=\"submit\" class=\"Button\" style=\"width: 100%;\" value=\"Save\" ></td></tr>"
echo "</form>"
echo "<tr><td id=\"ruler\"/><td id=\"ruler\"/></tr>"

#####WLAN Log configuration#####

echo "<tr><td></td><td><h3>WLAN Logs(<a href="http://www.hetos.de/bwlog.html#config_wlanlogs">?</a>)</h3></td></tr>"

echo "<form action=\"http://$HTTP_HOST$SCRIPT_NAME\" method=\"POST\" >"
echo "<input type=\"hidden\" name=\"command\" value=\"rm ./data/assoclog ./data/preassoclist\">"
echo "<tr><td></td><td><input type=\"submit\" class=\"ButtonWarn\" style=\"width: 100%;\" value=\"Clear WLAN Logs\" ></td></tr>"
echo "</form>"

echo "<form action=\"http://$HTTP_HOST$SCRIPT_NAME\" method=\"POST\" >"

echo "<tr><td>WLAN logging active:</td>"
echo "<td><input type=\"text\" class=\"TextBox\" name=\"acceac\" style=\"width: 100%;\" value=\"$acceac\" ></td></tr>"

echo "<tr><td>Authorized hostnames on WLAN:</td>"
echo "<td><input type=\"text\" class=\"TextBox\" name=\"wlnhst\" style=\"width: 100%;\" value=\"$wlnhst\" ></td></tr>"

echo "<tr><td>Authorized MACs on WLAN:</td>"
echo "<td><input type=\"text\" class=\"TextBox\" name=\"wlnmac\" style=\"width: 100%;\" value=\"$wlnmac\" ></td></tr>"

echo "<tr><td>Custom script on other hostname/MAC:</td>"
echo "<td><input type=\"text\" class=\"TextBox\" name=\"wlncmd\" style=\"width: 100%;\" value=\"$wlncmd\" ></td></tr>"

echo "<input type=\"hidden\" name=\"cnfupd4\" value=\"1\" >"
echo "<tr><td></td><td><input type=\"submit\" class=\"Button\" style=\"width: 100%;\" value=\"Save\" ></td></tr>"
echo "</form>"
echo "<tr><td id=\"ruler\"/><td id=\"ruler\"/></tr>"

#####Backup configuration#####
echo "<tr><td></td><td><h3>Backup(<a href="http://www.hetos.de/bwlog.html#config_backup">?</a>)</h3></td></tr>"

echo "<form action=\"http://$HTTP_HOST$SCRIPT_NAME\" method=\"POST\" >"
echo "<input type=\"hidden\" name=\"command\" value=\"./custom.sh 2> /dev/null\">"
echo "<tr><td></td><td><input type=\"submit\" class=\"Button\" style=\"width: 100%;\" value=\"Upload custom WRTbwlog version\" ></td></tr>"
echo "</form>"

echo "<form action=\"http://$HTTP_HOST$SCRIPT_NAME\" method=\"POST\" >"
echo "<input type=\"hidden\" name=\"command\" value=\"./backup.sh r 2> /dev/null\">"
echo "<tr><td></td><td><input type=\"submit\" class=\"Button\" style=\"width: 100%;\" value=\"Restore last backup\" ></td></tr>"
echo "</form>"

echo "<form action=\"http://$HTTP_HOST$SCRIPT_NAME\" method=\"POST\" >"

echo "<tr><td>Backup active:</td>"
echo "<td><input type=\"text\" class=\"TextBox\" style=\"width: 100%;\" name=\"backac\" value=\"$backac\"></td></tr>"

echo "<tr><td>Backup interval:</td>"
echo "<td><input type=\"text\" class=\"TextBox\" style=\"width: 100%;\" name=\"intbac\" value=\"$intbac\"></td></tr>"

echo "<tr><td>Backup destination (FTP  or FLASH):</td>"
echo "<td><input type=\"text\" class=\"TextBox\" style=\"width: 100%;\" name=\"destbc\" value=\"$destbc\"></td></tr>"

echo "<tr><td>Backup path (flash only):</td>"
echo "<td><input type=\"text\" class=\"TextBox\" style=\"width: 100%;\" name=\"pathbc\" value=\"$pathbc\"></td></tr>"

echo "<tr><td>FTP server:</td>"
echo "<td><input type=\"text\" class=\"TextBox\" style=\"width: 100%;\" name=\"ftpbac\" value=\"$ftpbac\"></td></tr>"

echo "<tr><td>FTP user:</td>"
echo "<td><input type=\"text\" class=\"TextBox\" style=\"width: 100%;\" name=\"usrbac\" value=\"$usrbac\"></td></tr>"

echo "<tr><td>FTP password:</td>"
echo "<td><input type=\"text\" class=\"TextBox\" style=\"width: 100%;\" name=\"pasbac\" value=\"$pasbac\"></td></tr>"

echo "<tr><td>FTP rootdirectory:</td>"
echo "<td><input type=\"text\" class=\"TextBox\" style=\"width: 100%;\" name=\"rotbac\" value=\"$rotbac\"></td></tr>"

echo "<input type=\"hidden\" name=\"cnfupd5\" value=\"1\" >"
echo "<tr><td></td><td><input type=\"submit\" class=\"Button\" style=\"width: 100%;\" value=\"Save\" ></td></tr>"
echo "</form>"
echo "</table>"

#####restart services#####
if [ "$restart" != "" ]; then
  ./start.sh 1> /dev/null 2> /dev/null &
fi

./footer.sh
?>
